// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/vorteil/direktiv/ent/predicate"
	"github.com/vorteil/direktiv/ent/workflowevents"
)

// WorkflowEventsDelete is the builder for deleting a WorkflowEvents entity.
type WorkflowEventsDelete struct {
	config
	hooks    []Hook
	mutation *WorkflowEventsMutation
}

// Where appends a list predicates to the WorkflowEventsDelete builder.
func (wed *WorkflowEventsDelete) Where(ps ...predicate.WorkflowEvents) *WorkflowEventsDelete {
	wed.mutation.Where(ps...)
	return wed
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (wed *WorkflowEventsDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(wed.hooks) == 0 {
		affected, err = wed.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*WorkflowEventsMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			wed.mutation = mutation
			affected, err = wed.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(wed.hooks) - 1; i >= 0; i-- {
			if wed.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = wed.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, wed.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (wed *WorkflowEventsDelete) ExecX(ctx context.Context) int {
	n, err := wed.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (wed *WorkflowEventsDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: workflowevents.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: workflowevents.FieldID,
			},
		},
	}
	if ps := wed.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, wed.driver, _spec)
}

// WorkflowEventsDeleteOne is the builder for deleting a single WorkflowEvents entity.
type WorkflowEventsDeleteOne struct {
	wed *WorkflowEventsDelete
}

// Exec executes the deletion query.
func (wedo *WorkflowEventsDeleteOne) Exec(ctx context.Context) error {
	n, err := wedo.wed.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{workflowevents.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (wedo *WorkflowEventsDeleteOne) ExecX(ctx context.Context) {
	wedo.wed.ExecX(ctx)
}
