// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/google/uuid"
	"github.com/vorteil/direktiv/pkg/flow/ent/inode"
	"github.com/vorteil/direktiv/pkg/flow/ent/namespace"
	"github.com/vorteil/direktiv/pkg/flow/ent/predicate"
	"github.com/vorteil/direktiv/pkg/flow/ent/workflow"
)

// InodeUpdate is the builder for updating Inode entities.
type InodeUpdate struct {
	config
	hooks    []Hook
	mutation *InodeMutation
}

// Where appends a list predicates to the InodeUpdate builder.
func (iu *InodeUpdate) Where(ps ...predicate.Inode) *InodeUpdate {
	iu.mutation.Where(ps...)
	return iu
}

// SetUpdatedAt sets the "updated_at" field.
func (iu *InodeUpdate) SetUpdatedAt(t time.Time) *InodeUpdate {
	iu.mutation.SetUpdatedAt(t)
	return iu
}

// SetName sets the "name" field.
func (iu *InodeUpdate) SetName(s string) *InodeUpdate {
	iu.mutation.SetName(s)
	return iu
}

// SetNillableName sets the "name" field if the given value is not nil.
func (iu *InodeUpdate) SetNillableName(s *string) *InodeUpdate {
	if s != nil {
		iu.SetName(*s)
	}
	return iu
}

// ClearName clears the value of the "name" field.
func (iu *InodeUpdate) ClearName() *InodeUpdate {
	iu.mutation.ClearName()
	return iu
}

// SetAttributes sets the "attributes" field.
func (iu *InodeUpdate) SetAttributes(s []string) *InodeUpdate {
	iu.mutation.SetAttributes(s)
	return iu
}

// ClearAttributes clears the value of the "attributes" field.
func (iu *InodeUpdate) ClearAttributes() *InodeUpdate {
	iu.mutation.ClearAttributes()
	return iu
}

// SetNamespaceID sets the "namespace" edge to the Namespace entity by ID.
func (iu *InodeUpdate) SetNamespaceID(id uuid.UUID) *InodeUpdate {
	iu.mutation.SetNamespaceID(id)
	return iu
}

// SetNamespace sets the "namespace" edge to the Namespace entity.
func (iu *InodeUpdate) SetNamespace(n *Namespace) *InodeUpdate {
	return iu.SetNamespaceID(n.ID)
}

// AddChildIDs adds the "children" edge to the Inode entity by IDs.
func (iu *InodeUpdate) AddChildIDs(ids ...uuid.UUID) *InodeUpdate {
	iu.mutation.AddChildIDs(ids...)
	return iu
}

// AddChildren adds the "children" edges to the Inode entity.
func (iu *InodeUpdate) AddChildren(i ...*Inode) *InodeUpdate {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return iu.AddChildIDs(ids...)
}

// SetParentID sets the "parent" edge to the Inode entity by ID.
func (iu *InodeUpdate) SetParentID(id uuid.UUID) *InodeUpdate {
	iu.mutation.SetParentID(id)
	return iu
}

// SetNillableParentID sets the "parent" edge to the Inode entity by ID if the given value is not nil.
func (iu *InodeUpdate) SetNillableParentID(id *uuid.UUID) *InodeUpdate {
	if id != nil {
		iu = iu.SetParentID(*id)
	}
	return iu
}

// SetParent sets the "parent" edge to the Inode entity.
func (iu *InodeUpdate) SetParent(i *Inode) *InodeUpdate {
	return iu.SetParentID(i.ID)
}

// SetWorkflowID sets the "workflow" edge to the Workflow entity by ID.
func (iu *InodeUpdate) SetWorkflowID(id uuid.UUID) *InodeUpdate {
	iu.mutation.SetWorkflowID(id)
	return iu
}

// SetNillableWorkflowID sets the "workflow" edge to the Workflow entity by ID if the given value is not nil.
func (iu *InodeUpdate) SetNillableWorkflowID(id *uuid.UUID) *InodeUpdate {
	if id != nil {
		iu = iu.SetWorkflowID(*id)
	}
	return iu
}

// SetWorkflow sets the "workflow" edge to the Workflow entity.
func (iu *InodeUpdate) SetWorkflow(w *Workflow) *InodeUpdate {
	return iu.SetWorkflowID(w.ID)
}

// Mutation returns the InodeMutation object of the builder.
func (iu *InodeUpdate) Mutation() *InodeMutation {
	return iu.mutation
}

// ClearNamespace clears the "namespace" edge to the Namespace entity.
func (iu *InodeUpdate) ClearNamespace() *InodeUpdate {
	iu.mutation.ClearNamespace()
	return iu
}

// ClearChildren clears all "children" edges to the Inode entity.
func (iu *InodeUpdate) ClearChildren() *InodeUpdate {
	iu.mutation.ClearChildren()
	return iu
}

// RemoveChildIDs removes the "children" edge to Inode entities by IDs.
func (iu *InodeUpdate) RemoveChildIDs(ids ...uuid.UUID) *InodeUpdate {
	iu.mutation.RemoveChildIDs(ids...)
	return iu
}

// RemoveChildren removes "children" edges to Inode entities.
func (iu *InodeUpdate) RemoveChildren(i ...*Inode) *InodeUpdate {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return iu.RemoveChildIDs(ids...)
}

// ClearParent clears the "parent" edge to the Inode entity.
func (iu *InodeUpdate) ClearParent() *InodeUpdate {
	iu.mutation.ClearParent()
	return iu
}

// ClearWorkflow clears the "workflow" edge to the Workflow entity.
func (iu *InodeUpdate) ClearWorkflow() *InodeUpdate {
	iu.mutation.ClearWorkflow()
	return iu
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (iu *InodeUpdate) Save(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	iu.defaults()
	if len(iu.hooks) == 0 {
		if err = iu.check(); err != nil {
			return 0, err
		}
		affected, err = iu.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*InodeMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = iu.check(); err != nil {
				return 0, err
			}
			iu.mutation = mutation
			affected, err = iu.sqlSave(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(iu.hooks) - 1; i >= 0; i-- {
			if iu.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = iu.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, iu.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// SaveX is like Save, but panics if an error occurs.
func (iu *InodeUpdate) SaveX(ctx context.Context) int {
	affected, err := iu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (iu *InodeUpdate) Exec(ctx context.Context) error {
	_, err := iu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (iu *InodeUpdate) ExecX(ctx context.Context) {
	if err := iu.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (iu *InodeUpdate) defaults() {
	if _, ok := iu.mutation.UpdatedAt(); !ok {
		v := inode.UpdateDefaultUpdatedAt()
		iu.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (iu *InodeUpdate) check() error {
	if v, ok := iu.mutation.Name(); ok {
		if err := inode.NameValidator(v); err != nil {
			return &ValidationError{Name: "name", err: fmt.Errorf("ent: validator failed for field \"name\": %w", err)}
		}
	}
	if _, ok := iu.mutation.NamespaceID(); iu.mutation.NamespaceCleared() && !ok {
		return errors.New("ent: clearing a required unique edge \"namespace\"")
	}
	return nil
}

func (iu *InodeUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := &sqlgraph.UpdateSpec{
		Node: &sqlgraph.NodeSpec{
			Table:   inode.Table,
			Columns: inode.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: inode.FieldID,
			},
		},
	}
	if ps := iu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := iu.mutation.UpdatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: inode.FieldUpdatedAt,
		})
	}
	if value, ok := iu.mutation.Name(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: inode.FieldName,
		})
	}
	if iu.mutation.NameCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: inode.FieldName,
		})
	}
	if value, ok := iu.mutation.Attributes(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeJSON,
			Value:  value,
			Column: inode.FieldAttributes,
		})
	}
	if iu.mutation.AttributesCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeJSON,
			Column: inode.FieldAttributes,
		})
	}
	if iu.mutation.NamespaceCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   inode.NamespaceTable,
			Columns: []string{inode.NamespaceColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: namespace.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iu.mutation.NamespaceIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   inode.NamespaceTable,
			Columns: []string{inode.NamespaceColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: namespace.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if iu.mutation.ChildrenCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   inode.ChildrenTable,
			Columns: []string{inode.ChildrenColumn},
			Bidi:    true,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iu.mutation.RemovedChildrenIDs(); len(nodes) > 0 && !iu.mutation.ChildrenCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   inode.ChildrenTable,
			Columns: []string{inode.ChildrenColumn},
			Bidi:    true,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iu.mutation.ChildrenIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   inode.ChildrenTable,
			Columns: []string{inode.ChildrenColumn},
			Bidi:    true,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if iu.mutation.ParentCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   inode.ParentTable,
			Columns: []string{inode.ParentColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iu.mutation.ParentIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   inode.ParentTable,
			Columns: []string{inode.ParentColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if iu.mutation.WorkflowCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2O,
			Inverse: false,
			Table:   inode.WorkflowTable,
			Columns: []string{inode.WorkflowColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: workflow.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iu.mutation.WorkflowIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2O,
			Inverse: false,
			Table:   inode.WorkflowTable,
			Columns: []string{inode.WorkflowColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: workflow.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, iu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{inode.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{err.Error(), err}
		}
		return 0, err
	}
	return n, nil
}

// InodeUpdateOne is the builder for updating a single Inode entity.
type InodeUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *InodeMutation
}

// SetUpdatedAt sets the "updated_at" field.
func (iuo *InodeUpdateOne) SetUpdatedAt(t time.Time) *InodeUpdateOne {
	iuo.mutation.SetUpdatedAt(t)
	return iuo
}

// SetName sets the "name" field.
func (iuo *InodeUpdateOne) SetName(s string) *InodeUpdateOne {
	iuo.mutation.SetName(s)
	return iuo
}

// SetNillableName sets the "name" field if the given value is not nil.
func (iuo *InodeUpdateOne) SetNillableName(s *string) *InodeUpdateOne {
	if s != nil {
		iuo.SetName(*s)
	}
	return iuo
}

// ClearName clears the value of the "name" field.
func (iuo *InodeUpdateOne) ClearName() *InodeUpdateOne {
	iuo.mutation.ClearName()
	return iuo
}

// SetAttributes sets the "attributes" field.
func (iuo *InodeUpdateOne) SetAttributes(s []string) *InodeUpdateOne {
	iuo.mutation.SetAttributes(s)
	return iuo
}

// ClearAttributes clears the value of the "attributes" field.
func (iuo *InodeUpdateOne) ClearAttributes() *InodeUpdateOne {
	iuo.mutation.ClearAttributes()
	return iuo
}

// SetNamespaceID sets the "namespace" edge to the Namespace entity by ID.
func (iuo *InodeUpdateOne) SetNamespaceID(id uuid.UUID) *InodeUpdateOne {
	iuo.mutation.SetNamespaceID(id)
	return iuo
}

// SetNamespace sets the "namespace" edge to the Namespace entity.
func (iuo *InodeUpdateOne) SetNamespace(n *Namespace) *InodeUpdateOne {
	return iuo.SetNamespaceID(n.ID)
}

// AddChildIDs adds the "children" edge to the Inode entity by IDs.
func (iuo *InodeUpdateOne) AddChildIDs(ids ...uuid.UUID) *InodeUpdateOne {
	iuo.mutation.AddChildIDs(ids...)
	return iuo
}

// AddChildren adds the "children" edges to the Inode entity.
func (iuo *InodeUpdateOne) AddChildren(i ...*Inode) *InodeUpdateOne {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return iuo.AddChildIDs(ids...)
}

// SetParentID sets the "parent" edge to the Inode entity by ID.
func (iuo *InodeUpdateOne) SetParentID(id uuid.UUID) *InodeUpdateOne {
	iuo.mutation.SetParentID(id)
	return iuo
}

// SetNillableParentID sets the "parent" edge to the Inode entity by ID if the given value is not nil.
func (iuo *InodeUpdateOne) SetNillableParentID(id *uuid.UUID) *InodeUpdateOne {
	if id != nil {
		iuo = iuo.SetParentID(*id)
	}
	return iuo
}

// SetParent sets the "parent" edge to the Inode entity.
func (iuo *InodeUpdateOne) SetParent(i *Inode) *InodeUpdateOne {
	return iuo.SetParentID(i.ID)
}

// SetWorkflowID sets the "workflow" edge to the Workflow entity by ID.
func (iuo *InodeUpdateOne) SetWorkflowID(id uuid.UUID) *InodeUpdateOne {
	iuo.mutation.SetWorkflowID(id)
	return iuo
}

// SetNillableWorkflowID sets the "workflow" edge to the Workflow entity by ID if the given value is not nil.
func (iuo *InodeUpdateOne) SetNillableWorkflowID(id *uuid.UUID) *InodeUpdateOne {
	if id != nil {
		iuo = iuo.SetWorkflowID(*id)
	}
	return iuo
}

// SetWorkflow sets the "workflow" edge to the Workflow entity.
func (iuo *InodeUpdateOne) SetWorkflow(w *Workflow) *InodeUpdateOne {
	return iuo.SetWorkflowID(w.ID)
}

// Mutation returns the InodeMutation object of the builder.
func (iuo *InodeUpdateOne) Mutation() *InodeMutation {
	return iuo.mutation
}

// ClearNamespace clears the "namespace" edge to the Namespace entity.
func (iuo *InodeUpdateOne) ClearNamespace() *InodeUpdateOne {
	iuo.mutation.ClearNamespace()
	return iuo
}

// ClearChildren clears all "children" edges to the Inode entity.
func (iuo *InodeUpdateOne) ClearChildren() *InodeUpdateOne {
	iuo.mutation.ClearChildren()
	return iuo
}

// RemoveChildIDs removes the "children" edge to Inode entities by IDs.
func (iuo *InodeUpdateOne) RemoveChildIDs(ids ...uuid.UUID) *InodeUpdateOne {
	iuo.mutation.RemoveChildIDs(ids...)
	return iuo
}

// RemoveChildren removes "children" edges to Inode entities.
func (iuo *InodeUpdateOne) RemoveChildren(i ...*Inode) *InodeUpdateOne {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return iuo.RemoveChildIDs(ids...)
}

// ClearParent clears the "parent" edge to the Inode entity.
func (iuo *InodeUpdateOne) ClearParent() *InodeUpdateOne {
	iuo.mutation.ClearParent()
	return iuo
}

// ClearWorkflow clears the "workflow" edge to the Workflow entity.
func (iuo *InodeUpdateOne) ClearWorkflow() *InodeUpdateOne {
	iuo.mutation.ClearWorkflow()
	return iuo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (iuo *InodeUpdateOne) Select(field string, fields ...string) *InodeUpdateOne {
	iuo.fields = append([]string{field}, fields...)
	return iuo
}

// Save executes the query and returns the updated Inode entity.
func (iuo *InodeUpdateOne) Save(ctx context.Context) (*Inode, error) {
	var (
		err  error
		node *Inode
	)
	iuo.defaults()
	if len(iuo.hooks) == 0 {
		if err = iuo.check(); err != nil {
			return nil, err
		}
		node, err = iuo.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*InodeMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = iuo.check(); err != nil {
				return nil, err
			}
			iuo.mutation = mutation
			node, err = iuo.sqlSave(ctx)
			mutation.done = true
			return node, err
		})
		for i := len(iuo.hooks) - 1; i >= 0; i-- {
			if iuo.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = iuo.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, iuo.mutation); err != nil {
			return nil, err
		}
	}
	return node, err
}

// SaveX is like Save, but panics if an error occurs.
func (iuo *InodeUpdateOne) SaveX(ctx context.Context) *Inode {
	node, err := iuo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (iuo *InodeUpdateOne) Exec(ctx context.Context) error {
	_, err := iuo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (iuo *InodeUpdateOne) ExecX(ctx context.Context) {
	if err := iuo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (iuo *InodeUpdateOne) defaults() {
	if _, ok := iuo.mutation.UpdatedAt(); !ok {
		v := inode.UpdateDefaultUpdatedAt()
		iuo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (iuo *InodeUpdateOne) check() error {
	if v, ok := iuo.mutation.Name(); ok {
		if err := inode.NameValidator(v); err != nil {
			return &ValidationError{Name: "name", err: fmt.Errorf("ent: validator failed for field \"name\": %w", err)}
		}
	}
	if _, ok := iuo.mutation.NamespaceID(); iuo.mutation.NamespaceCleared() && !ok {
		return errors.New("ent: clearing a required unique edge \"namespace\"")
	}
	return nil
}

func (iuo *InodeUpdateOne) sqlSave(ctx context.Context) (_node *Inode, err error) {
	_spec := &sqlgraph.UpdateSpec{
		Node: &sqlgraph.NodeSpec{
			Table:   inode.Table,
			Columns: inode.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: inode.FieldID,
			},
		},
	}
	id, ok := iuo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "ID", err: fmt.Errorf("missing Inode.ID for update")}
	}
	_spec.Node.ID.Value = id
	if fields := iuo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, inode.FieldID)
		for _, f := range fields {
			if !inode.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != inode.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := iuo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := iuo.mutation.UpdatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: inode.FieldUpdatedAt,
		})
	}
	if value, ok := iuo.mutation.Name(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: inode.FieldName,
		})
	}
	if iuo.mutation.NameCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: inode.FieldName,
		})
	}
	if value, ok := iuo.mutation.Attributes(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeJSON,
			Value:  value,
			Column: inode.FieldAttributes,
		})
	}
	if iuo.mutation.AttributesCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeJSON,
			Column: inode.FieldAttributes,
		})
	}
	if iuo.mutation.NamespaceCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   inode.NamespaceTable,
			Columns: []string{inode.NamespaceColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: namespace.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iuo.mutation.NamespaceIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   inode.NamespaceTable,
			Columns: []string{inode.NamespaceColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: namespace.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if iuo.mutation.ChildrenCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   inode.ChildrenTable,
			Columns: []string{inode.ChildrenColumn},
			Bidi:    true,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iuo.mutation.RemovedChildrenIDs(); len(nodes) > 0 && !iuo.mutation.ChildrenCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   inode.ChildrenTable,
			Columns: []string{inode.ChildrenColumn},
			Bidi:    true,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iuo.mutation.ChildrenIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   inode.ChildrenTable,
			Columns: []string{inode.ChildrenColumn},
			Bidi:    true,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if iuo.mutation.ParentCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   inode.ParentTable,
			Columns: []string{inode.ParentColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iuo.mutation.ParentIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   inode.ParentTable,
			Columns: []string{inode.ParentColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: inode.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if iuo.mutation.WorkflowCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2O,
			Inverse: false,
			Table:   inode.WorkflowTable,
			Columns: []string{inode.WorkflowColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: workflow.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iuo.mutation.WorkflowIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2O,
			Inverse: false,
			Table:   inode.WorkflowTable,
			Columns: []string{inode.WorkflowColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: workflow.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Inode{config: iuo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, iuo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{inode.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{err.Error(), err}
		}
		return nil, err
	}
	return _node, nil
}
